//   Plugin popup notifications for vacuum-im (c) Crying Angel, 2010
//   This plugin uses notifications developed by Sidorov "Sauron" Aleksey

//   This library is free software; you can redistribute it and/or
//   modify it under the terms of the GNU Library General Public
//   License version 2 or later as published by the Free Software Foundation.
//
//   This library is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//   Library General Public License for more details.
//
//   You should have received a copy of the GNU Library General Public License
//   along with this library; see the file COPYING.LIB.  If not, write to
//   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
//   Boston, MA 02110-1301, USA.

#ifndef NOTIFICATIONS_H
#define NOTIFICATIONS_H

#include <definitions/notificationdataroles.h>
#include <interfaces/ipluginmanager.h>
#include <interfaces/inotifications.h>
#include <interfaces/iavatars.h>
#include "kineticnotification.h"
#include <definitions/optionvalues.h>
#include <utils/options.h>

#ifdef SVNINFO
#  include "svninfo.h"
#else
#  define SVN_REVISION              "0"
#endif

#define KIPOPUPHANDLER_UUID  "{AE779B91-8087-4713-8BDD-5951CB219EB2}"
#define NHO_KIPOPUP              2000

class KineticPopupHandler :
			public QObject,
			public IPlugin,
                        public INotificationHandler
{
	Q_OBJECT;
        Q_INTERFACES(IPlugin INotificationHandler);
public:
        KineticPopupHandler();
        ~KineticPopupHandler();
	//IPlugin
	virtual QObject *instance() { return this; }
        virtual QUuid pluginUuid() const { return KIPOPUPHANDLER_UUID; }
	virtual void pluginInfo(IPluginInfo *APluginInfo);
	virtual bool initConnections(IPluginManager *APluginManager, int &AInitOrder);
	virtual bool initObjects();
	virtual bool initSettings();
	virtual bool startPlugin() { return true; }
        //INotificationHandler
        virtual bool showNotification(int AOrder, ushort AKind, int ANotifyId, const INotification &ANotification);

protected slots:
	void onWindowNotifyActivated();
        void onWindowNotifyRemoved(/*int ANotifyId*/);
        void onApplicationQuit ();

private:
	IAvatars *FAvatars;
        INotifications *FNotifications;
        KineticNotification *FNotify;

        int FTimeout;
};

#endif // NOTIFICATIONS_H
